#TEMPLATE (A_SubClass,'For subclassing windows.')
#!
#!*************************************************************************
#! FREEWARE FREEWARE FREEWARE FREEWARE FREEWARE FREEWARE FREEWARE FREEWARE
#!*************************************************************************
#!
#!  The author accepts NO liability for the use of this template.
#!  It is provided, "AS IS" for use or edit by anyone.
#!  (but if you use it and don't GPF<g>, a "thank you" would be nice)
#!
#!  The author acknowledges the helpful suggestions and previous
#!  labor of some "Brit"<bg> in the creation of this template.
#!
#!*************************************************************************
#!
#!  SubClassWindow: For subclassing a CW window.
#!
#EXTENSION(SubClassWindow, 'Subclass a window'),PROCEDURE,LAST
#BOXED ('SubClass A Window')
  #BOXED ('')
    #DISPLAY('')
    #DISPLAY('This template subclasses this procedure window.')
    #DISPLAY('')
  #ENDBOXED
#DISPLAY('')
#BUTTON ('Case Statement'),MULTI(%sClassingFields,%sClassField&'('&%sClassHexValue&') ; '&%sClassOperation)
  #BOXED('(none required)')
  #DISPLAY('')
  #PROMPT ('"OF" Message:', @s20), %sClassField, REQ
  #PROMPT ('HEX Equate:', @s10), %sClassHexValue, REQ
  #VALIDATE((INSTRING('H',%sClassHexValue)) OR (INSTRING('h',%sClassHexValue)), 'Must include "H" in HEX Value')
  #PROMPT ('Operation:', @s255), %sClassOperation, REQ
  #DISPLAY('')
  #BOXED('Examples')
  #DISPLAY('')
  #DISPLAY('WM_QUERYENDSESSION')
  #DISPLAY('011H')
  #DISPLAY('POST(EVENT:CloseDown,,1) ; RETURN(1)')
  #DISPLAY('')
  #DISPLAY('WM_ENDSESSION')
  #DISPLAY('016H')
  #DISPLAY('Halt()')
  #DISPLAY('')
  #ENDBOXED
  #DISPLAY('')
  #ENDBOXED
#ENDBUTTON
#ENDBOXED
#AT(%ModuleDataSection)

  !==================================================== SubClassWindow Template
  MAP
    SubClassProcWindow(USHORT,SHORT,SHORT,LONG),LONG,PASCAL
    MODULE('')
      scSetWindowLong(USHORT,SHORT,LONG),LONG,RAW,PASCAL,NAME('SetWindowLong')
      scCallWindowProc(LONG,USHORT,SHORT,SHORT,LONG),LONG,RAW,PASCAL,NAME('CallWindowProc')
    END
  END

SubClassWindow       LONG
#FOR (%sClassingFields)
%[20]sClassField EQUATE(%sClassHexValue)
#ENDFOR

#ENDAT
#AT(%AfterWindowOpening)

!====================================================== SubClassWindow Template
SubClassWindow = scSetWindowLong(0{PROP:Handle},-4,ADDRESS(SubClassProcWindow))

#ENDAT
#AT(%ProcedureRoutines)

!====================================================== SubClassWindow Template
SubClassProcWindow   FUNCTION(hWnd,WinMsg,wParam,lParam)

  CODE
  #IF (%sClassingFields)
  CASE WinMsg
  #FOR (%sClassingFields)
  OF %sClassField
    %sClassOperation
  #ENDFOR
  END
  #ENDIF
  RETURN(scCallWindowProc(SubClassWindow,hWnd,WinMsg,wParam,lParam))

#ENDAT
